#ifndef TEXTURE_H
#define TEXTURE_H
#include <stdlib.h>
#include "data.h"

struct texture_search {
  struct texture_search *next;
  char *search;
  unsigned short found;
};

struct texture_replace {
  struct texture_replace *next;
  char *search;
  char *replace;
  unsigned short found;
  unsigned short replaced;
};

struct texture_set {
  struct texture_set *next;
  unsigned short number;
  char *set;
};

GSM_API struct texture **alloc_textures(unsigned short);
GSM_API struct texture **alloc_more_textures(unsigned short, unsigned short, struct texture **);
GSM_API struct texture *alloc_texture();
GSM_API void cleanup_textures(unsigned short, struct texture **);
GSM_API int find_textures(struct gsm *);
GSM_API int parse_texture(struct gsm *, unsigned short, struct texture *, unsigned short);
GSM_API int write_textures(struct gsm *);
/* texture search and replace strings */
GSM_API struct texture_search *alloc_texture_search();
GSM_API void cleanup_texture_searches(struct texture_search *);
GSM_API int add_to_texture_search(struct texture_search **, char *);
GSM_API struct texture_replace *alloc_texture_replace();
GSM_API void cleanup_texture_replaces(struct texture_replace *);
GSM_API int add_to_texture_replace(struct texture_replace **, char *, char *);
GSM_API struct texture_set *alloc_texture_set();
GSM_API void cleanup_texture_sets(struct texture_set *);
GSM_API int add_to_texture_set(struct texture_set **, char *, char *);
GSM_API int list_textures(struct gsm *);
GSM_API int replace_textures(struct gsm *);
GSM_API int replace_texture(struct texture *, struct texture_replace *);
GSM_API int set_textures(struct gsm *);
GSM_API int set_texture(struct texture *, char *);
GSM_API struct gll *find_texture(struct texture *, struct texture_search *);
GSM_API char *get_texture_name(struct gsm *, unsigned short);
GSM_API int describe_textures(struct gsm *);

struct texture {
  unsigned int offset;
  unsigned short filename_length;
  char *filename;
  unsigned short basename_length;
  char *basename;
};

#endif
